<template>
    <i-form :model="this.data" class='app-form' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emplantempl.main3_form.details.grouppanel2')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.emplantemplid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emplantemplid' :itemRules="this.rules.emplantemplid" class='' :caption="$t('entities.emplantempl.main3_form.details.emplantemplid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emplantemplid.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.emplantemplid"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.emplantemplid.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.emplantemplname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emplantemplname' :itemRules="this.rules.emplantemplname" class='' :caption="$t('entities.emplantempl.main3_form.details.emplantemplname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emplantemplname.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.emplantemplname"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.emplantemplname.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.plantype.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='plantype' :itemRules="this.rules.plantype" class='' :caption="$t('entities.emplantempl.main3_form.details.plantype')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.plantype.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.plantype" :data="data" :itemParam="{}" :disabled="detailsModel.plantype.disabled"  tag='EMPLANTYPE' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.planstate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='planstate' :itemRules="this.rules.planstate" class='' :caption="$t('entities.emplantempl.main3_form.details.planstate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.planstate.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.planstate" :data="data" :itemParam="{}" :disabled="detailsModel.planstate.disabled"  tag='EMPLANSTATE' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.mdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='mdate' :itemRules="this.rules.mdate" class='' :caption="$t('entities.emplantempl.main3_form.details.mdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.mdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="datetime" :transfer="true" format="yyyy-MM-dd HH:mm:ss" placeholder="请选择时间..." :value="data.mdate" :disabled="detailsModel.mdate.disabled" style="min-width: 150px; width:160px;" @on-change="(val1, val2) => { this.data.mdate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.prefee.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='prefee' :itemRules="this.rules.prefee" class='' :caption="$t('entities.emplantempl.main3_form.details.prefee')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.prefee.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.prefee"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.prefee.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.activelengths.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='activelengths' :itemRules="this.rules.activelengths" class='' :caption="$t('entities.emplantempl.main3_form.details.activelengths')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.activelengths.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.activelengths"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.activelengths.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqstoplength.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqstoplength' :itemRules="this.rules.eqstoplength" class='' :caption="$t('entities.emplantempl.main3_form.details.eqstoplength')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqstoplength.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.eqstoplength"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.eqstoplength.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.mtflag.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='mtflag' :itemRules="this.rules.mtflag" class='' :caption="$t('entities.emplantempl.main3_form.details.mtflag')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.mtflag.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.mtflag" :data="data" :itemParam="{}" :disabled="detailsModel.mtflag.disabled" style="width:100px;width: 100px;" tag='YesNo' codelistType='STATIC'  placeholder='请选择...'></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.emwotype.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emwotype' :itemRules="this.rules.emwotype" class='' :caption="$t('entities.emplantempl.main3_form.details.emwotype')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emwotype.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.emwotype" :data="data" :itemParam="{}" :disabled="detailsModel.emwotype.disabled"  tag='EMWOKIND' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.plancvl.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='plancvl' :itemRules="this.rules.plancvl" class='' :caption="$t('entities.emplantempl.main3_form.details.plancvl')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.plancvl.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.plancvl"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.plancvl.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.plandesc.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='plandesc' :itemRules="this.rules.plandesc" class='' :caption="$t('entities.emplantempl.main3_form.details.plandesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.plandesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <div class="ivu-input-wrapper ivu-input-wrapper-default ivu-input-type">
    <textarea class="ivu-input" :rows="10" v-model="data.plandesc" :disabled="detailsModel.plandesc.disabled" style="height:200px;"></textarea>
</div>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel15.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel15.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emplantempl.main3_form.details.grouppanel15')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.mpersonname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='mpersonname' :itemRules="this.rules.mpersonname" class='' :caption="$t('entities.emplantempl.main3_form.details.mpersonname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.mpersonname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.mpersonname.disabled"
  name='mpersonname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='mpersonid' 
  :value="data.mpersonname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.rempname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.emplantempl.main3_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rempname.disabled"
  name='rempname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='rempid' 
  :value="data.rempname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.rdeptname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rdeptname' :itemRules="this.rules.rdeptname" class='' :caption="$t('entities.emplantempl.main3_form.details.rdeptname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rdeptname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rdeptname.disabled"
  name='rdeptname'
  deMajorField='pfdeptname'
  deKeyField='pfdept'
  :service="service"
  :acParams="{ serviceName: 'PFDeptService', interfaceName: 'FetchDefault'}"
  valueitem='rdeptid' 
  :value="data.rdeptname" 
  editortype="" 
  :pickupView="{ viewname: 'pfdeptpickup-view', title: $t('entities.pfdept.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfdepts', parameterName: 'pfdept' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.rteamname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rteamname' :itemRules="this.rules.rteamname" class='' :caption="$t('entities.emplantempl.main3_form.details.rteamname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rteamname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rteamname.disabled"
  name='rteamname'
  deMajorField='pfteamname'
  deKeyField='pfteam'
  :service="service"
  :acParams="{ serviceName: 'PFTeamService', interfaceName: 'FetchDefault'}"
  valueitem='rteamid' 
  :value="data.rteamname" 
  editortype="" 
  :pickupView="{ viewname: 'pfteampickup-view', title: $t('entities.pfteam.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfteams', parameterName: 'pfteam' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.rservicename.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rservicename' :itemRules="this.rules.rservicename" class='' :caption="$t('entities.emplantempl.main3_form.details.rservicename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rservicename.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rservicename.disabled"
  name='rservicename'
  deMajorField='emservicename'
  deKeyField='emservice'
  :service="service"
  :acParams="{ serviceName: 'EMServiceService', interfaceName: 'FetchDefault'}"
  valueitem='rserviceid' 
  :value="data.rservicename" 
  editortype="" 
  :pickupView="{ viewname: 'emservicepickup-view', title: $t('entities.emservice.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emservices', parameterName: 'emservice' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.recvpersonname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='recvpersonname' :itemRules="this.rules.recvpersonname" class='' :caption="$t('entities.emplantempl.main3_form.details.recvpersonname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.recvpersonname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.recvpersonname.disabled"
  name='recvpersonname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='recvpersonid' 
  :value="data.recvpersonname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel22.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel22.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emplantempl.main3_form.details.grouppanel22')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.archive.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='archive' :itemRules="this.rules.archive" class='' :caption="$t('entities.emplantempl.main3_form.details.archive')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.archive.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-checkbox-list v-model="data.archive" :disabled="detailsModel.archive.disabled"  tag='EMARCHIVE' codelistType='STATIC' valueSeparator=";"  mode="str" name="archive" style=""></app-checkbox-list>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMPlanTemplService from '@/service/emplan-templ/emplan-templ-service';
import Main3Service from './main3-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main3Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main3
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main3
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main3
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main3
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main3
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main3
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main3Service}
     * @memberof Main3
     */
    public service: Main3Service = new Main3Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMPlanTemplService}
     * @memberof Main3
     */
    public appEntityService: EMPlanTemplService = new EMPlanTemplService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main3
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main3
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main3
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main3
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main3
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main3
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main3
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main3
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main3
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main3
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main3
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main3
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main3
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        emplantemplid: null,
        emplantemplname: null,
        plantype: null,
        planstate: null,
        mdate: null,
        prefee: null,
        activelengths: null,
        eqstoplength: null,
        mtflag: null,
        emwotype: null,
        plancvl: null,
        plandesc: null,
        mpersonname: null,
        rempname: null,
        rdeptname: null,
        rteamname: null,
        rservicename: null,
        recvpersonname: null,
        archive: null,
        rempid: null,
        rserviceid: null,
        recvpersonid: null,
        rdeptid: null,
        rteamid: null,
        mpersonid: null,
        emplantempl:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main3
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main3
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main3
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main3
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main3
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '计划模板编号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '计划模板编号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '计划模板编号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '计划模板编号 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '计划模板名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '计划模板名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '计划模板名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '计划模板名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        emplantemplid: [
            { type: 'string', message: '模板编号(自动) 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '模板编号(自动) 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '模板编号(自动) 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '模板编号(自动) 值不能为空', trigger: 'blur' },
        ],
        emplantemplname: [
            { type: 'string', message: '计划模板名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '计划模板名称 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '计划模板名称 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '计划模板名称 值不能为空', trigger: 'blur' },
        ],
        plantype: [
            { type: 'string', message: '计划类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '计划类型 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '计划类型 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '计划类型 值不能为空', trigger: 'blur' },
        ],
        planstate: [
            { type: 'number', message: '计划状态 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '计划状态 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '计划状态 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '计划状态 值不能为空', trigger: 'blur' },
        ],
        mdate: [
            { type: 'string', message: '制定时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '制定时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '制定时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '制定时间 值不能为空', trigger: 'blur' },
        ],
        prefee: [
            { type: 'string', message: '预算(￥) 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '预算(￥) 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '预算(￥) 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '预算(￥) 值不能为空', trigger: 'blur' },
        ],
        activelengths: [
            { type: 'number', message: '持续时间(H) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '持续时间(H) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '持续时间(H) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '持续时间(H) 值不能为空', trigger: 'blur' },
        ],
        eqstoplength: [
            { type: 'number', message: '停运时间(分) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '停运时间(分) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '停运时间(分) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '停运时间(分) 值不能为空', trigger: 'blur' },
        ],
        mtflag: [
            { type: 'number', message: '多任务? 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '多任务? 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '多任务? 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '多任务? 值不能为空', trigger: 'blur' },
        ],
        emwotype: [
            { type: 'string', message: '生成工单种类 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '生成工单种类 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '生成工单种类 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '生成工单种类 值不能为空', trigger: 'blur' },
        ],
        plancvl: [
            { type: 'number', message: '计划周期(天) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '计划周期(天) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '计划周期(天) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '计划周期(天) 值不能为空', trigger: 'blur' },
        ],
        plandesc: [
            { type: 'string', message: '计划内容 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '计划内容 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '计划内容 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '计划内容 值不能为空', trigger: 'blur' },
        ],
        mpersonname: [
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'blur' },
        ],
        rdeptname: [
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'blur' },
        ],
        rteamname: [
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'blur' },
        ],
        rservicename: [
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'blur' },
        ],
        recvpersonname: [
            { type: 'string', message: '接收人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '接收人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '接收人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '接收人 值不能为空', trigger: 'blur' },
        ],
        archive: [
            { type: 'string', message: '归档 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '归档 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '归档 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '归档 值不能为空', trigger: 'blur' },
        ],
        rempid: [
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'blur' },
        ],
        rserviceid: [
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'blur' },
        ],
        recvpersonid: [
            { type: 'string', message: '接收人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '接收人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '接收人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '接收人 值不能为空', trigger: 'blur' },
        ],
        rdeptid: [
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'blur' },
        ],
        rteamid: [
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'blur' },
        ],
        mpersonid: [
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main3
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '计划模板信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emplantempl.main3_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel15: new FormGroupPanelModel({ caption: '责任信息', detailType: 'GROUPPANEL', name: 'grouppanel15', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emplantempl.main3_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel22: new FormGroupPanelModel({ caption: '归档信息', detailType: 'GROUPPANEL', name: 'grouppanel22', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emplantempl.main3_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '计划模板编号', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '计划模板名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emplantemplid: new FormItemModel({ caption: '模板编号(自动)', detailType: 'FORMITEM', name: 'emplantemplid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        emplantemplname: new FormItemModel({ caption: '计划模板名称', detailType: 'FORMITEM', name: 'emplantemplname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        plantype: new FormItemModel({ caption: '计划类型', detailType: 'FORMITEM', name: 'plantype', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        planstate: new FormItemModel({ caption: '计划状态', detailType: 'FORMITEM', name: 'planstate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        mdate: new FormItemModel({ caption: '制定时间', detailType: 'FORMITEM', name: 'mdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        prefee: new FormItemModel({ caption: '预算(￥)', detailType: 'FORMITEM', name: 'prefee', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        activelengths: new FormItemModel({ caption: '持续时间(H)', detailType: 'FORMITEM', name: 'activelengths', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqstoplength: new FormItemModel({ caption: '停运时间(分)', detailType: 'FORMITEM', name: 'eqstoplength', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        mtflag: new FormItemModel({ caption: '多任务?', detailType: 'FORMITEM', name: 'mtflag', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emwotype: new FormItemModel({ caption: '生成工单种类', detailType: 'FORMITEM', name: 'emwotype', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        plancvl: new FormItemModel({ caption: '计划周期(天)', detailType: 'FORMITEM', name: 'plancvl', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        plandesc: new FormItemModel({ caption: '计划内容', detailType: 'FORMITEM', name: 'plandesc', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        mpersonname: new FormItemModel({ caption: '制定人', detailType: 'FORMITEM', name: 'mpersonname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '责任人', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rdeptname: new FormItemModel({ caption: '责任部门', detailType: 'FORMITEM', name: 'rdeptname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rteamname: new FormItemModel({ caption: '责任班组', detailType: 'FORMITEM', name: 'rteamname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rservicename: new FormItemModel({ caption: '服务商', detailType: 'FORMITEM', name: 'rservicename', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        recvpersonname: new FormItemModel({ caption: '接收人', detailType: 'FORMITEM', name: 'recvpersonname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        archive: new FormItemModel({ caption: '归档', detailType: 'FORMITEM', name: 'archive', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempid: new FormItemModel({ caption: '责任人', detailType: 'FORMITEM', name: 'rempid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rserviceid: new FormItemModel({ caption: '服务商', detailType: 'FORMITEM', name: 'rserviceid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        recvpersonid: new FormItemModel({ caption: '接收人', detailType: 'FORMITEM', name: 'recvpersonid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rdeptid: new FormItemModel({ caption: '责任部门', detailType: 'FORMITEM', name: 'rdeptid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rteamid: new FormItemModel({ caption: '责任班组', detailType: 'FORMITEM', name: 'rteamid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        mpersonid: new FormItemModel({ caption: '制定人', detailType: 'FORMITEM', name: 'mpersonid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emplantemplid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.emplantemplid')
    onEmplantemplidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emplantemplid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emplantemplname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.emplantemplname')
    onEmplantemplnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emplantemplname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 plantype 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.plantype')
    onPlantypeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'plantype', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 planstate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.planstate')
    onPlanstateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'planstate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 mdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.mdate')
    onMdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'mdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 prefee 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.prefee')
    onPrefeeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'prefee', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 activelengths 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.activelengths')
    onActivelengthsChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'activelengths', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqstoplength 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.eqstoplength')
    onEqstoplengthChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqstoplength', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 mtflag 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.mtflag')
    onMtflagChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'mtflag', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emwotype 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.emwotype')
    onEmwotypeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emwotype', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 plancvl 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.plancvl')
    onPlancvlChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'plancvl', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 plandesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.plandesc')
    onPlandescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'plandesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 mpersonname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.mpersonname')
    onMpersonnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'mpersonname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rdeptname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rdeptname')
    onRdeptnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rdeptname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rteamname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rteamname')
    onRteamnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rteamname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rservicename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rservicename')
    onRservicenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rservicename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 recvpersonname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.recvpersonname')
    onRecvpersonnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'recvpersonname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 archive 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.archive')
    onArchiveChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'archive', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rempid')
    onRempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rserviceid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rserviceid')
    onRserviceidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rserviceid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 recvpersonid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.recvpersonid')
    onRecvpersonidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'recvpersonid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rdeptid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rdeptid')
    onRdeptidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rdeptid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rteamid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.rteamid')
    onRteamidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rteamid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 mpersonid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main3
     */
    @Watch('data.mpersonid')
    onMpersonidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'mpersonid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main3
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main3
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                





































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main3
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main3
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emplantempl){
            Object.assign(this.context,{emplantempl:data.emplantempl})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main3
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main3
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main3
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main3
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main3
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main3
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main3
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main3
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main3
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main3
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main3
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main3
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main3
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main3
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main3
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main3
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'计划模板<主编辑>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main3
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main3
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main3
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMPLANTEMPLEditView_EditMode视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main3
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMPLANTEMPLEditView_EditMode视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emplantempl){
                Object.assign(this.context,{emplantempl:data.emplantempl})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main3
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMPLANTEMPLEditView_EditMode视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main3
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMPLANTEMPLEditView_EditMode视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMPLANTEMPLEditView_EditMode视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main3
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main3
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emplantempl || Object.is(arg.emplantempl, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main3
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main3
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main3
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main3
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main3
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main3
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main3
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main3
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main3-form.less';
</style>